<!--
OpenVAS Administrator
$Id$
Description: OAP schema with embedded documentation, in OAP.

Authors:
Matthew Mundell <matthew.mundell@greenbone.de>

Copyright:
Copyright (C) 2010 Greenbone Networks GmbH

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2,
or, at your option, any later version as published by the Free
Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
-->


<!--
CHANGES:

  From version 1.0 to version 1.1:
  ================================

    Support for authentication sources was added.

    - "<create_user>" and "<modify_user>": a new optional element "<sources>"
      was added to set/modify possible authentication sources per user.
    - "<get_users>": responses contain the respective "<sources>" element (per
      user).

-->


<protocol>
  <name>OpenVAS Administrator Protocol</name>
  <abbreviation>OAP</abbreviation>
  <summary>The "administrator" protocol of the Open Vulnerability Assessment System</summary>
  <version>1.1</version>
  <type>
    <name>base64</name>
    <summary>Base64 encoded data</summary>
    <pattern>xsd:base64Binary</pattern>
  </type>
  <type>
    <name>boolean</name>
    <summary>A true or false value</summary>
    <description>
      Zero is false, anything else is true.  As a result, the empty string is
      considered true.
    </description>
    <pattern>text</pattern>
  </type>
  <type>
    <name>boolean_atoi</name>
    <summary>A true or false value, after conversion to an integer</summary>
    <description>
      Zero is false, anything else is true.  The value is first converted to
      an integer, as by the C `atoi' routine.  This means that an empty string
      is considered false.
    </description>
    <pattern>text</pattern>
  </type>
  <type>
    <name>ctime</name>
    <summary>A date and time, in the C `ctime' format</summary>
    <description>
      An example string in this format is "Wed Jun 30 21:49:08 1993\n".
    </description>
    <pattern>text</pattern>
  </type>
  <type>
    <name>type_name</name>
    <summary>A name of a data type</summary>
    <pattern>xsd:string - xsd:whitespace</pattern>
  </type>
  <type>
    <name>integer</name>
    <summary>An integer</summary>
    <pattern>xsd:integer</pattern>
  </type>
  <type>
    <name>levels</name>
    <summary>A string that may include the characters h, m, l, g and d</summary>
    <pattern>xsd:token { pattern = "h?m?l?g?d?" }</pattern>
  </type>
  <type>
    <name>name</name>
    <summary>A name</summary>
    <pattern>xsd:string</pattern>
  </type>
  <type>
    <name>oid</name>
    <summary>An Object Identifier (OID)</summary>
    <pattern>xsd:token { pattern = "[0-9\.]{1,80}" }</pattern>
  </type>
  <type>
    <name>sort_order</name>
    <summary>A string describing an order for sorting</summary>
    <description>
      The string "descending" denotes descending order, anything else means
      ascending.
    </description>
    <pattern>text</pattern>
  </type>
  <type>
    <name>status</name>
    <summary>The success or failure status of a command</summary>
    <pattern>xsd:token { pattern = "200|201|202|400|401|403|404|409|500|503" }</pattern>
  </type>
  <type>
    <name>task_status</name>
    <summary>A task run status</summary>
    <pattern>
      xsd:token { pattern = "Delete Requested|Done|New|Pause Requested|Paused|Requested|Resume Requested|Running|Stop Requested|Stopped|Internal Error" }
    </pattern>
  </type>
  <type>
    <name>task_trend</name>
    <summary>The trend of results for a task</summary>
    <pattern>
      xsd:token { pattern = "up|down|more|less|same" }
    </pattern>
  </type>
  <type>
    <name>threat</name>
    <summary>A threat level</summary>
    <pattern>xsd:token { pattern = "High|Medium|Low|Log|Debug" }</pattern>
  </type>
  <type>
    <name>time_unit</name>
    <summary>A unit of time</summary>
    <pattern>xsd:token { pattern = "second|minute|hour|day|week|month|year|decade" }</pattern>
  </type>
  <type>
    <name>uuid</name>
    <summary>A Universally Unique Identifier (UUID)</summary>
    <pattern>xsd:token { pattern = "[0-9abcdefABCDEF\-]{1,40}" }</pattern>
  </type>
  <type>
    <name>uuid_or_empty</name>
    <summary>A Universally Unique Identifier (UUID), or the empty string</summary>
    <pattern>xsd:token { pattern = "[0-9abcdefABCDEF\-]{0,40}" }</pattern>
  </type>
  <element>
    <name>c</name>
    <summary>A reference to a command</summary>
    <pattern>text</pattern>
  </element>
  <element>
    <name>e</name>
    <summary>A reference to an element</summary>
    <pattern>text</pattern>
  </element>
  <element>
    <name>r</name>
    <summary>A reference to a response</summary>
    <pattern>text</pattern>
  </element>
  <element>
    <name>o</name>
    <summary>An optional pattern item</summary>
    <pattern>
      <or>
        <e>c</e>
        <e>e</e>
        <e>r</e>
        <e>g</e>
      </or>
    </pattern>
  </element>
  <element>
    <name>g</name>
    <summary>A group of pattern items</summary>
    <pattern>
      <any><e>c</e></any>
      <any><e>e</e></any>
      <any><e>r</e></any>
      <any><e>o</e></any>
      <any><e>any</e></any>
    </pattern>
  </element>
  <element>
    <name>any</name>
    <summary>Pattern item indicating "any number of"</summary>
    <pattern>
      <or>
        <e>c</e>
        <e>e</e>
        <e>r</e>
        <e>g</e>
      </or>
    </pattern>
  </element>
  <element>
    <name>pattern</name>
    <summary>The pattern element of a command or command descendant</summary>
    <description>
      It's actually either a 't' element, or the word "text", or "".
    </description>
    <pattern>
      <any><e>attrib</e></any>
      <any><e>c</e></any>
      <any><e>e</e></any>
      <any><e>r</e></any>
      <any><e>o</e></any>
      <any><e>g</e></any>
      <any><e>any</e></any>
      <o><e>t</e></o>
      text
    </pattern>
    <ele>
      <name>attrib</name>
      <summary>An attribute</summary>
      <pattern>
        <e>name</e>
        <e>type</e>
        <e>required</e>
      </pattern>
      <ele>
        <name>name</name>
        <pattern><t>type_name</t></pattern>
      </ele>
      <ele>
        <name>type</name>
        <pattern><t>type_name</t></pattern>
      </ele>
      <ele>
        <name>required</name>
        <pattern><t>boolean</t></pattern>
      </ele>
    </ele>
    <ele>
      <name>t</name>
      <summary>The type of the text of the element</summary>
      <pattern><t>type_name</t></pattern>
    </ele>
  </element>
  <element>
    <name>command_definition</name>
    <summary>Definition of a command in OAP describing HELP command</summary>
    <pattern>
      <e>name</e>
      <o><e>summary</e></o>
      <o><e>description</e></o>
      <or>
        <g>
          <e>pattern</e>
          <e>response</e>
        </g>
        <g>
          <e>type</e>
          <any><e>ele</e></any>
        </g>
      </or>
      <any><e>example</e></any>
    </pattern>
    <ele>
      <name>name</name>
      <summary>The name of the command</summary>
      <description>The name must be unique</description>
      <pattern><t>type_name</t></pattern>
    </ele>
    <ele>
      <name>summary</name>
      <summary>A summary of the command</summary>
      <pattern>text</pattern>
    </ele>
    <ele>
      <name>description</name>
      <summary>A description of the command</summary>
      <pattern>
        <any><e>p</e></any>
        text
      </pattern>
      <ele>
        <name>p</name>
        <summary>A paragraph</summary>
        <pattern>text</pattern>
      </ele>
    </ele>
    <ele>
      <name>pattern</name>
      <type>pattern</type>
    </ele>
    <ele>
      <name>response</name>
      <type>pattern</type>
    </ele>
    <ele>
      <name>example</name>
      <pattern>
        <o><e>summary</e></o>
        <o><e>description</e></o>
        <e>request</e>
        <e>response</e>
      </pattern>
      <ele>
        <name>summary</name>
        <pattern>text</pattern>
      </ele>
      <ele>
        <name>description</name>
        <pattern>text</pattern>
      </ele>
      <ele>
        <name>request</name>
        <summary>Example request</summary>
        <description>This can actually contain any XML</description>
        <pattern>text</pattern>
      </ele>
      <ele>
        <name>response</name>
        <summary>Response to example request</summary>
        <description>This can actually contain any XML</description>
        <pattern>text</pattern>
      </ele>
    </ele>
    <ele>
      <name>type</name>
      <summary>The type of the element</summary>
      <pattern>text</pattern>
    </ele>
    <ele>
      <name>ele</name>
      <summary>An element</summary>
      <description>
        <p>
          This is a recursive definition.
        </p>
        <p>
          command_definition actually includes an extra response element, but
          it's convenient to use it for the elements.
        </p>
      </description>
      <type>command_definition</type>
    </ele>
  </element>
  <element>
    <name>sources</name>
    <summary>List of authentication sources associated to a user</summary>
    <pattern>
      <any><e>source</e></any>
    </pattern>
    <ele>
      <name>source</name>
      <summary>The name of the authentication source</summary>
      <description>The name must be unique</description>
      <pattern>text</pattern>
    </ele>
  </element>
  <command>
    <name>authenticate</name>
    <summary>Authenticate with the Administrator</summary>
    <description>
      <p>
        The client uses the authenticate command to authenticate with the
        Administrator.
      </p>
      <p>
        The client normally executes this command at the beginning of each
        connection.  The only commands permitted before authentication are
        get_version and commands.
      </p>
    </description>
    <pattern>
      <e>credentials</e>
    </pattern>
    <ele>
      <name>credentials</name>
      <pattern>
        <e>username</e>
        <e>password</e>
      </pattern>
      <ele>
        <name>username</name>
        <summary>The login name of the user</summary>
        <pattern>
          text
        </pattern>
      </ele>
      <ele>
        <name>password</name>
        <summary>The user's password</summary>
        <pattern>
          text
        </pattern>
      </ele>
    </ele>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Authenticate with a good password</summary>
      <request>
        <authenticate>
          <credentials>
            <username>sally</username>
            <password>secret</password>
          </credentials>
        </authenticate>
      </request>
      <response>
        <authenticate_response status="200" status_text="OK"/>
      </response>
    </example>
    <example>
      <summary>Authenticate with a bad password</summary>
      <request>
        <authenticate>
          <credentials>
            <username>sally</username>
            <password>secrte</password>
          </credentials>
        </authenticate>
      </request>
      <response>
        <authenticate_response status="400"
                               status_text="Authentication failed"/>
      </response>
    </example>
  </command>
  <command>
    <name>commands</name>
    <summary>Run a list of commands</summary>
    <description>
      The client uses the commands command to run a list of commands.  The
      elements are executed as OAP commands in the given sequence.  The reply
      contains the result of each command, in the same order as the given
      commands.
    </description>
    <pattern>
      <any>
        <or>
          <c>authenticate</c>
          <c>commands</c>
          <c>create_user</c>
          <c>delete_user</c>
          <c>describe_auth</c>
          <c>describe_feed</c>
          <c>describe_scap</c>
          <c>describe_cert</c>
          <c>get_settings</c>
          <c>get_users</c>
          <c>get_version</c>
          <c>help</c>
          <c>modify_auth</c>
          <c>modify_user</c>
          <c>sync_feed</c>
          <c>sync_scap</c>
          <c>sync_cert</c>
        </or>
      </any>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <any>
          <or>
            <r>authenticate</r>
            <r>commands</r>
            <r>create_user</r>
            <r>delete_user</r>
            <r>describe_auth</r>
            <r>describe_feed</r>
            <r>describe_scap</r>
            <r>describe_cert</r>
            <r>get_settings</r>
            <r>get_users</r>
            <r>get_version</r>
            <r>help</r>
            <r>modify_auth</r>
            <r>modify_user</r>
            <r>sync_feed</r>
            <r>sync_scap</r>
            <r>sync_cert</r>
          </or>
        </any>
      </pattern>
    </response>
  </command>
  <command>
    <name>create_user</name>
    <summary>Create a user</summary>
    <description>
      <p>
        The client uses the create_user command to create a new user.
      </p>
    </description>
    <pattern>
      <e>name</e>
      <o><e>hosts</e></o>
      <o><e>password</e></o>
      <o><e>role</e></o>
    </pattern>
    <ele>
      <name>name</name>
      <summary>The name of the user to be created</summary>
      <pattern>text</pattern>
    </ele>
    <ele>
      <name>hosts</name>
      <summary>User access rules: a textual list of hosts</summary>
      <pattern>
        <attrib>
          <name>allow</name>
          <type>boolean</type>
        </attrib>
        text
      </pattern>
    </ele>
    <ele>
      <name>password</name>
      <summary>The password for the user</summary>
      <pattern>text</pattern>
    </ele>
    <ele>
      <name>role</name>
      <summary>The role of the user</summary>
      <pattern>
        <t>
          <alts>
            <alt>Administrator</alt>
            <alt>User</alt>
            <alt>Observer</alt>
          </alts>
        </t>
      </pattern>
    </ele>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>id</name>
          <type>uuid</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Create a user</summary>
      <request>
        <create_user>
          <name>foobar</name>
          <password>f00bar</password>
          <role>User</role>
        </create_user>
      </request>
      <response>
        <create_user_response status="201" status_text="OK, resource created"/>
      </response>
    </example>
  </command>
  <command>
    <name>delete_user</name>
    <summary>Delete a user</summary>
    <description>
      <p>
        The client uses the delete_user command to delete an existing user.
      </p>
      <p>
        Since this is a destructive command, the client is advised to ask
        for confirmation from the user before sending this command to the
        Administrator.
      </p>
    </description>
    <pattern>
      <e>name</e>
    </pattern>
    <ele>
      <name>name</name>
      <summary>The name of the user to be deleted</summary>
      <pattern>text</pattern>
    </ele>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Delete a user</summary>
      <request>
        <delete_user name="foobar">
        </delete_user>
      </request>
      <response>
        <delete_user_response status="200" status_text="OK">
        </delete_user_response>
      </response>
    </example>
  </command>
  <command>
    <name>describe_auth</name>
    <summary>Describe a auth</summary>
    <description>
      <p>
        The client uses the "describe_auth" command to get details about the
        used authentication methods.
      </p>
      <p>
        The administrator will reply with a list of all used authentication
        methods if such a list is available.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <e>group</e>
      </pattern>
      <ele>
        <name>group</name>
        <summary>Config group</summary>
        <pattern>
          <attrib>
            <name>name</name>
            <type>text</type>
            <required>1</required>
          </attrib>
          <e>auth_conf_setting</e>
        </pattern>
        <ele>
          <name>auth_conf_setting</name>
          <pattern>
            <attrib>
              <name>key</name>
              <type>text</type>
              <required>1</required>
            </attrib>
            <attrib>
              <name>value</name>
              <type>text</type>
              <required>1</required>
            </attrib>
          </pattern>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Describe the authentication methods</summary>
      <request>
        <describe_auth>
        </describe_auth>
      </request>
      <response>
        <describe_auth_response status="200" status_text="OK">
          <group name="Foo">
            <auth_conf_setting key="Bar" value="Baz"/>
          </group>
        </describe_auth_response>
      </response>
    </example>
  </command>
  <command>
    <name>describe_feed</name>
    <summary>Describe the NVT feed</summary>
    <description>
      <p>
        The client uses the "describe_feed" command to get details about
        the NVT feed used by the administrator.
      </p>
      <p>
        The Administrator will reply with a feed element containing
        information about the NVT feed.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <e>feed</e>
      </pattern>
      <ele>
        <name>feed</name>
        <pattern>
          <e>name</e>
          <e>version</e>
          <e>description</e>
        </pattern>
        <ele>
          <name>name</name>
          <summary>The name of the feed</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>version</name>
          <summary>The version of the feed</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>description</name>
          <summary>A description of the feed</summary>
          <pattern>text</pattern>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Describe the feed</summary>
      <request>
        <describe_feed>
        </describe_feed>
      </request>
      <response>
        <describe_feed_response status="200" status_text="OK">
          <feed>
            <name>OpenVAS NVT Feed</name>
            <version>201011221324</version>
            <description>
              The 'OpenVAS NVT Feed' is provided by 'The OpenVAS Project'.
              <truncated>...</truncated>
            </description>
          </feed>
        </describe_feed_response>
      </response>
    </example>
  </command>
  <command>
    <name>describe_scap</name>
    <summary>Describe the SCAP feed</summary>
    <description>
      <p>
        The client uses the "describe_scap" command to get details about
        the SCAP feed used by the administrator.
      </p>
      <p>
        The Administrator will reply with a scap element containing
        information about the SCAP feed.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <e>scap</e>
      </pattern>
      <ele>
        <name>scap</name>
        <pattern>
          <e>name</e>
          <e>version</e>
          <e>description</e>
        </pattern>
        <ele>
          <name>name</name>
          <summary>The name of the scap feed</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>version</name>
          <summary>The version of the scap feed</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>description</name>
          <summary>A description of the scap feed</summary>
          <pattern>text</pattern>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Describe the scap feed</summary>
      <request>
        <describe_scap>
        </describe_scap>
      </request>
      <response>
        <describe_scap_response status="200" status_text="OK">
          <scap>
            <name>OpenVAS NVT SCAP</name>
            <version>201011221324</version>
            <description>
              The 'OpenVAS SCAP Feed' is provided by 'The OpenVAS Project'.
              <truncated>...</truncated>
            </description>
          </scap>
        </describe_scap_response>
      </response>
    </example>
  </command>
    <command>
    <name>describe_cert</name>
    <summary>Describe the CERT feed</summary>
    <description>
      <p>
        The client uses the "describe_cert" command to get details about
        the CERT feed used by the administrator.
      </p>
      <p>
        The Administrator will reply with a cert element containing
        information about the CERT feed.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <e>cert</e>
      </pattern>
      <ele>
        <name>cert</name>
        <pattern>
          <e>name</e>
          <e>version</e>
          <e>description</e>
        </pattern>
        <ele>
          <name>name</name>
          <summary>The name of the CERT feed</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>version</name>
          <summary>The version of the CERT feed</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>description</name>
          <summary>A description of the CERT feed</summary>
          <pattern>text</pattern>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Describe the CERT feed</summary>
      <request>
        <describe_cert>
        </describe_cert>
      </request>
      <response>
        <describe_cert_response status="200" status_text="OK">
          <cert>
            <name>OpenVAS CERT Feed</name>
            <version>201301040805</version>
            <description>
              The 'OpenVAS CERT Feed' is provided by 'The OpenVAS Project'.
              <truncated>...</truncated>
            </description>
          </cert>
        </describe_cert_response>
      </response>
    </example>
  </command>
  <command>
    <name>get_settings</name>
    <summary>Get all settings</summary>
    <description>
      <p>
        The client uses the "get_settings" command to retrieve a list of all
        settings set for the Scanner controlled by this Administrator.
      </p>
      <p>
        The Administrator will reply with a list of all known settings and
        their values.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <e>scanner_settings</e>
      </pattern>
      <ele>
        <name>scanner_settings</name>
        <pattern>
          <any><e>setting</e></any>
        </pattern>
        <ele>
          <name>setting</name>
          <summary>The name of the setting</summary>
          <pattern>
            <attrib>
              <name>name</name>
              <type>text</type>
              <required>1</required>
            </attrib>
            text
          </pattern>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Get the settings</summary>
      <request>
        <get_settings></get_settings>
      </request>
      <response>
        <get_settings_response status="200" status_text="OK">
          <scanner_settings sourcefile="/etc/openvas/openvassd.conf" editable="0">
            <setting name="safe_checks">yes</setting>
            <truncated>...</truncated>
          </scanner_settings>
        </get_settings_response>
      </response>
    </example>
  </command>
  <command>
    <name>get_users</name>
    <summary>Get all users</summary>
    <description>
      <p>
        The client uses the "get_users" command to retrieve the list of user
        accounts on the Scanner.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <any><e>user</e></any>
      </pattern>
      <ele>
        <name>user</name>
        <pattern>
          <e>name</e>
          <e>role</e>
          <e>hosts</e>
          <e>sources</e>
        </pattern>
        <ele>
          <name>name</name>
          <summary>The name of the user</summary>
          <pattern>text</pattern>
        </ele>
        <ele>
          <name>role</name>
          <summary>The role of the user</summary>
          <pattern>
            <t>
              <alts>
                <alt>Admin</alt>
                <alt>User</alt>
                <alt>Observer</alt>
              </alts>
            </t>
          </pattern>
        </ele>
        <ele>
          <name>hosts</name>
          <summary>Host access rule for the user</summary>
          <pattern>
            <attrib>
              <name>allow</name>
              <summary>0 forbidden, 1 allowed, 2 all allowed, 3 custom</summary>
              <type>
                <alts>
                  <alt>0</alt>
                  <alt>1</alt>
                  <alt>2</alt>
                  <alt>3</alt>
                </alts>
              </type>
              <required>1</required>
            </attrib>
            text
          </pattern>
        </ele>
        <ele>
          <name>sources</name>
          <summary>Sources allowed for authentication for this user</summary>
          <type>sources</type>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Get the users</summary>
      <request>
        <get_users></get_users>
      </request>
      <response>
        <get_users_response status="200" status_text="OK">
          <user>
            <name>foobar</name>
            <role>User</role>
            <hosts allow="2"></hosts>
            <sources><source>file</source></sources>
          </user>
        </get_users_response>
      </response>
    </example>
  </command>
  <command>
    <name>get_version</name>
    <summary>Get the OpenVAS Administrator Protocol version</summary>
    <pattern></pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <e>version</e>
      </pattern>
      <ele>
        <name>version</name>
        <pattern>text</pattern>
      </ele>
    </response>
    <example>
      <summary>Get the version</summary>
      <request>
        <get_version></get_version>
      </request>
      <response>
        <get_version_response status="200" status_text="OK">
          <version>1.0</version>
        </get_version_response>
      </response>
    </example>
  </command>
  <command>
    <name>help</name>
    <summary>Get the help text</summary>
    <pattern>
      <attrib>
        <name>format</name>
        <summary>Required help format</summary>
        <type>
          <alts>
            <alt>html</alt>
            <alt>HTML</alt>
            <alt>rnc</alt>
            <alt>RNC</alt>
            <alt>text</alt>
            <alt>TEXT</alt>
            <alt>xml</alt>
            <alt>XML</alt>
          </alts>
        </type>
      </attrib>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
        <o><e>schema</e></o>
        text
      </pattern>
      <ele>
        <name>schema</name>
        <pattern><e>protocol</e></pattern>
        <ele>
          <name>protocol</name>
          <pattern>
            <e>name</e>
            <o><e>abbreviation</e></o>
            <o><e>summary</e></o>
            <o><e>version</e></o>
            <any><e>type</e></any>
            <any><e>command</e></any>
          </pattern>
          <ele>
            <name>name</name>
            <summary>The full name of the protocol</summary>
            <pattern>text</pattern>
          </ele>
          <ele>
            <name>abbreviation</name>
            <summary>The abbreviated name of the protocol</summary>
            <pattern>text</pattern>
          </ele>
          <ele>
            <name>summary</name>
            <summary>A summary of the protocol</summary>
            <pattern>text</pattern>
          </ele>
          <ele>
            <name>version</name>
            <summary>The version number of the protocol</summary>
            <pattern>text</pattern>
          </ele>
          <ele>
            <name>type</name>
            <summary>A data type</summary>
            <pattern>
              <e>name</e>
              <o><e>summary</e></o>
              <o><e>description</e></o>
              <e>pattern</e>
            </pattern>
            <ele>
              <name>name</name>
              <summary>The name of the data type</summary>
              <pattern><t>type_name</t></pattern>
            </ele>
            <ele>
              <name>summary</name>
              <summary>A summary of the data type</summary>
              <pattern>text</pattern>
            </ele>
            <ele>
              <name>description</name>
              <summary>A description of the data type</summary>
              <pattern>
                <any><e>p</e></any>
                text
              </pattern>
              <ele>
                <name>p</name>
                <summary>A paragraph</summary>
                <pattern>text</pattern>
              </ele>
            </ele>
            <ele>
              <name>pattern</name>
              <summary>The RNC pattern for the data type</summary>
              <pattern>text</pattern>
            </ele>
          </ele>
          <ele>
            <name>command</name>
            <summary>A command</summary>
            <type>command_definition</type>
          </ele>
        </ele>
      </ele>
    </response>
    <example>
      <summary>Get the help text</summary>
      <request>
        <help></help>
      </request>
      <response>
        <help_response status="200" status_text="OK">
            AUTHENTICATE     Authenticate with the administrator.
            COMMANDS         Run a list of commands.
            CREATE_USER      Create a new user.
            DELETE_USER      Delete an existing user.
            DESCRIBE_AUTH    Get details about the used authentication methods.
            DESCRIBE_FEED    Get details of the NVT feed this administrator uses.
            DESCRIBE_SCAP    Get details of the SCAP feed this administrator uses.
            DESCRIBE_CERT    Get details of the CERT feed this administrator uses.
            GET_SETTINGS     Get scanner settings.
            GET_USERS        Get all users.
            GET_VERSION      Get the OpenVAS Administrator Protocol version.
            HELP             Get this help text.
            MODIFY_AUTH      Modify the authentication methods.
            MODIFY_USER      Modify a user.
            SYNC_FEED        Synchronize with an NVT feed.
            SYNC_SCAP        Synchronize with a SCAP feed.
            SYNC_CERT        Synchronize with a CERT feed.
        </help_response>
      </response>
    </example>
    <example>
      <summary>Get the OAP schema</summary>
      <request>
        <help format="XML"></help>
      </request>
      <response>
        <help_response status="200" status_text="OK">
          <schema format="XML" extension="xml" content_type="text/xml">
            <protocol>
              <name>OpenVAS Administrator Protocol</name>
              <abbreviation>OAP</abbreviation>
              <summary>The "administrator" protocol of the Open Vulnerability Assessment System</summary>
              <version>1.0</version>
              <type>
                <name>base64</name>
                <summary>Base64 encoded data</summary>
                <pattern>xsd:base64Binary</pattern>
              </type>
              <truncated>...</truncated>
              <command>
                <name>authenticate</name>
                <summary>Authenticate with the Administrator</summary>
                <description>
                  <p>
                    The client uses the authenticate command to authenticate with the
                    Administrator.
                  </p>
                  <p>
                    The client normally executes this command at the beginning of each
                    connection.  The only commands permitted before authentication are
                    get_version and commands.
                  </p>
                </description>
                <pattern>
                  <e>credentials</e>
                </pattern>
                <ele>
                  <name>credentials</name>
                  <pattern>
                    <e>username</e>
                    <e>password</e>
                  </pattern>
                  <ele>
                    <name>username</name>
                    <summary>The login name of the user</summary>
                    <pattern>
                      text
                    </pattern>
                  </ele>
                  <ele>
                    <name>password</name>
                    <summary>The user's password</summary>
                    <pattern>
                      text
                    </pattern>
                  </ele>
                </ele>
                <response>
                  <pattern>
                    <attrib>
                      <name>status</name>
                      <type>status</type>
                      <required>1</required>
                    </attrib>
                    <attrib>
                      <name>status_text</name>
                      <type>text</type>
                      <required>1</required>
                    </attrib>
                  </pattern>
                </response>
                <example>
                  <summary>Authenticate with a good password</summary>
                  <request>
                    <authenticate>
                      <credentials>
                        <username>sally</username>
                        <password>secret</password>
                      </credentials>
                    </authenticate>
                  </request>
                  <response>
                    <authenticate_response status="200" status_text="OK">
                    </authenticate_response>
                  </response>
                </example>
                <truncated>...</truncated>
              </command>
              <truncated>...</truncated>
            </protocol>
          </schema>
        </help_response>
      </response>
    </example>
  </command>
  <command>
    <name>modify_auth</name>
    <summary>Modify the authentication methods</summary>
    <description>
      <p>
        The client uses the "modify_auth" command to modify the authentication
        methods.
      </p>
    </description>
    <pattern>
      <e>group</e>
    </pattern>
    <ele>
      <name>group</name>
      <pattern>
        <any><e>auth_conf_setting</e></any>
      </pattern>
      <ele>
        <name>auth_conf_setting</name>
        <summary>A setting to modify</summary>
        <pattern>
          <attrib>
            <name>key</name>
            <type>text</type>
            <required>1</required>
          </attrib>
          <attrib>
            <name>value</name>
            <type>text</type>
            <required>1</required>
          </attrib>
        </pattern>
      </ele>
    </ele>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Modify a single setting for an authentication method</summary>
      <request>
        <modify_auth>
          <group name="Foo">
            <auth_conf_setting key="Bar" value="Baz"/>
          </group>
        </modify_auth>
      </request>
      <response>
        <modify_auth_response status="200" status_text="OK">
        </modify_auth_response>
      </response>
    </example>
  </command>
  <command>
    <name>modify_user</name>
    <summary>Modify a user</summary>
    <description>
      <p>
        The client uses the "modify_user" command to modify an user account
        on the OpenVAS server.
      </p>
    </description>
    <pattern>
      <e>name</e>
      <o><e>password</e></o>
      <e>role</e>
      <o><e>hosts</e></o>
      <o><e>sources</e></o>
    </pattern>
    <ele>
      <name>name</name>
      <summary>The name of the user to be modified</summary>
      <pattern>text</pattern>
    </ele>
    <ele>
      <name>hosts</name>
      <summary>User access rules: a textual list of hosts</summary>
      <description>
        User is allowed to access any host if this element is missing.
      </description>
      <pattern>
        <attrib>
          <name>allow</name>
          <type>boolean</type>
        </attrib>
        text
      </pattern>
    </ele>
    <ele>
      <name>password</name>
      <summary>The password for the user</summary>
      <pattern>text</pattern>
    </ele>
    <ele>
      <name>role</name>
      <summary>The role of the user</summary>
      <pattern>
        <t>
          <alts>
            <alt>Administrator</alt>
            <alt>User</alt>
            <alt>Observer</alt>
          </alts>
        </t>
      </pattern>
    </ele>
    <ele>
      <name>sources</name>
      <summary>List of authentication sources for this user (if omitted, no changes)</summary>
      <type>sources</type>
    </ele>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Modify a user</summary>
      <request>
        <modify_user>
          <name>Foobar</name>
          <password modify="0"></password>
          <role>Admin</role>
          <hosts allow="0"></hosts>
        </modify_user>
      </request>
      <response>
        <modify_user_response status="200" status_text="OK">
        </modify_user_response>
      </response>
    </example>
  </command>
  <command>
    <name>sync_feed</name>
    <summary>Synchronize with an NVT feed</summary>
    <description>
      <p>
        The client uses the "sync_feed" command to request a
        synchronization with the NVT feed service the Administrator uses.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Sync the feed</summary>
      <request>
        <sync_feed>
        </sync_feed>
      </request>
      <response>
        <sync_feed_response status="202" status_text="OK, request submitted"/>
      </response>
    </example>
  </command>
  <command>
    <name>sync_scap</name>
    <summary>Synchronize with a SCAP feed</summary>
    <description>
      <p>
        The client uses the "sync_scap" command to request a
        synchronization with the SCAP feed service the Administrator uses.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Sync the feed</summary>
      <request>
        <sync_scap>
        </sync_scap>
      </request>
      <response>
        <sync_scap_response status="202" status_text="OK, request submitted"/>
      </response>
    </example>
  </command>
  <command>
    <name>sync_cert</name>
    <summary>Synchronize with a CERT feed</summary>
    <description>
      <p>
        The client uses the "sync_cert" command to request a
        synchronization with the CERT feed service the Administrator uses.
      </p>
    </description>
    <pattern>
    </pattern>
    <response>
      <pattern>
        <attrib>
          <name>status</name>
          <type>status</type>
          <required>1</required>
        </attrib>
        <attrib>
          <name>status_text</name>
          <type>text</type>
          <required>1</required>
        </attrib>
      </pattern>
    </response>
    <example>
      <summary>Sync the feed</summary>
      <request>
        <sync_cert>
        </sync_cert>
      </request>
      <response>
        <sync_cert_response status="202" status_text="OK, request submitted"/>
      </response>
    </example>
  </command>
</protocol>
